;======================================================
; 
;WREG = 
;FSR0 = Address
;======================================================
CLEAR:
        clrf    INDF0,ACCE
        inf     FSR0L,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     CLEAR
        ret  
;================================================================
;fsr0  add   fsr1buf ,result in r_Source  ,  r_Len length 
addblk:
        mvf      r_Len,F,ACCE
        bcf      status,c,ACCE
addblk_a:
	call	SWFSR01
	mvffs	INDF0,INDF1BUF
	call	SWFSR01
	mvf	INDF1BUF,W,ACCE
        addc     indf0,f,ACCE
        insz      FSR0L,F,ACCE
        nop
        insz      FSR1BUF,F,ACCE
        nop
        dcsz     r_Len,f,ACCE
        jmp      addblk_a
        ret
;======================================================
;˷  ( 뱻ҪͬһBank)
;md1     ļӵַ
;md2     ļӵַ
;md3     ļӵַ
;mdl1    ĳ
;mdl2    ĳ
;ĳΪ mdl1+mdl2
;S_REG,mdl3 Ĵ
;Cycle (2 byte * 2 byte) = 105
;======================================================
multiply:
        mvf      mdl2,W,ACCE
        addf     mdl1,w,ACCE
        mvf      s_reg,F,ACCE
        mvf      r_Len,F,ACCE
        mvffs     md3,fsr0L
        mvf      r_Len,W,ACCE
        call     clear

        mvl      8
        mvf      r_Len,F,ACCE
        mvf      mdl2,W,ACCE
        clrf     r_Len_c,ACCE
multiply_b:
        addf     r_Len_c,f,ACCE
        dcsz     r_Len,f,ACCE
        jmp      multiply_b     ; end of multuply
        inf      r_Len_c,f,ACCE
        bcf      md4,0,ACCE
        
multiply_tranf:
        mvffs    mdl2,r_Len
        dcf     wreg,f,ACCE
        addf    md2,w,ACCE
        mvf     fsr0L,F,ACCE
        rrfc    md4,W,ACCE
multiply_a:
        rrfc      indf0,f,ACCE
        dcsz      fsr0L,f,ACCE
        nop
        dcsz      r_Len,f,ACCE
        jmp      multiply_a
        mvl      1
        cpsg     r_Len_c,ACCE
        jmp     multiply_end

        btss     status,c,ACCE
        jmp      multiply_add_end
        bsf      md4,0,ACCE
        mvf      mdl2,W,ACCE
        addf     md3,w,ACCE
        mvf      fsr0L,F,ACCE
        mvffs     md1,FSR1BUF
        mvffs     mdl1,r_Len
        call     addblk
        bcf      r_Len,0,ACCE
        btss     status,c,ACCE
        jmp      mul_add_end_a
        bsf      r_Len,0,ACCE
        jmp      mul_add_end_a
multiply_add_end:
        bcf      md4,0,ACCE
mul_add_end_a:
        mvf      s_reg,W,ACCE
        dcf      wreg,f,ACCE
        addf     md3,w,ACCE          ; md3+len-1
        mvffs     wreg,FSR0L           ; C -> (md3+len-1) -> 
        rrfc     r_Len,W,ACCE
        mvf      s_reg,W,ACCE
multiply_loop:
        rrfc      indf0,f,ACCE
        dcsz      fsr0L,f,ACCE
        nop
        dcsz     wreg,f,ACCE
        jmp      multiply_loop

        dcsz      r_Len_c,f,ACCE
        jmp      multiply_tranf
multiply_end:
        ret

;======================================================
; (뱻ҪͬһBank)
;md1     ļӵַ
;md2     ļӵַ
;md3     ̵ļӵַ
;mdl1    ĳ
;mdl2    ĳ
;mdl3    ̵ĳ
;md4     (ĳ = 5)
;S_REG,r_Len Ĵ
;Cycle (4 byte / 2 byte) = 2209   Max
;======================================================
divide45:
        call     divide
        dcf      mdl2,w,ACCE
        addf     md2,w,ACCE
        mvf      FSR0L,F,ACCE
        mvf      mdl2,W,ACCE
        bcf      status,c,acce
     divide45_1:
        rrfc      INDF0,F,ACCE
        dcsz     FSR0L,F,ACCE
        nop
        dcsz     WREG,F,ACCE
        jmp      divide45_1
        mvl      md4
        mvf      FSR0L,F,ACCE
        mvffs     md2,FSR1BUF
        mvl       1            ; don't care Wreg   
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
     divide45_2:   
	call	SWFSR01
	mvffs	INDF0,INDF1BUF
	call	SWFSR01
	mvf	INDF1BUF,W,ACCE
	subc     INDF0,W,ACCE
        insz     FSR1BUF,F,ACCE
        nop
        insz     FSR0L,F,ACCE
        nop
        dcsz     mdl2,F,ACCE
        jmp      divide45_2
        btss     STATUS,C,ACCE
        ret
        mvffs     MD3,FSR0L         
        bcf      STATUS,C,ACCE
        mvl       1            ; don't care Wreg    
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
     divide45_3:   
        addc     INDF0,F,ACCE
        insz     FSR0L,F,ACCE
        nop
        dcsz     mdl3,F,ACCE
        jmp      divide45_3
        ret
;======================================================
;    (뱻ҪͬһBank)
;md1     ļӵַ
;md2     ļӵַ
;md3     ̵ļӵַ
;mdl1    ĳ
;mdl2    ĳ
;mdl3    ̵ĳ
;md4     (ĳ = 5)
;S_REG,r_Len Ĵ
;Cycle (4 byte / 2 byte) = 2179   Max
;======================================================
divide:
        mvl      MD4
        mvf      FSR0L,F,ACCE
        mvl      5
        call     clear
        mvffs     MD3,FSR0L           ; clear remainder
        mvf      mdl3,W,ACCE
        call     clear
        bcf     status,c
        rlfc     mdl1,W,ACCE
        rlfc     WREG,F,ACCE
        rlfc     WREG,F,ACCE
        mvf      S_REG,F,ACCE
     ;   mvf      mdl1,w,ACCE
     ;   mull     8
     ;   mvff     PRODL,S_REG    ; 8 * mdl1 --> S_REG
divlopk:
        mvffs    MD1,FSR0L
        mvf     mdl1,w,ACCE
        bcf     status,c,ACCE
divide_rlf_md1:
        rlfc    INDF0,F,ACCE
        insz     FSR0L,F,ACCE
        nop
        dcsz    WREG,F,ACCE
        jmp     divide_rlf_md1
      ;  LDPR    MD4,fsr0         ; md4 rotate left
        mvl      MD4
        mvf      FSR0L,F,ACCE
        mvf     mdl2,W,ACCE
divide_rlf_md4:
        rlfc    INDF0,f,ACCE
        insz     FSR0L,F,ACCE
        nop
        dcsz    WREG,F,ACCE
        jmp     divide_rlf_md4
        btsz    STATUS,C,ACCE
        jmp     div_sub_md4
       ; jc      div_sub_md4
       ; LDPR     MD4,FSR0
        mvl      MD4
        mvf      FSR0L,F,ACCE
        mvffs     MD2,FSR1BUF
        mvffs     mdl2,r_Len
        mvl       1            ; don't care Wreg    
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
     ;   bsf      STATUS,C,ACCE
  div_rlf_md4_next:        
	call	SWFSR01
	mvffs	INDF0,INDF1BUF
	call	SWFSR01
	mvf	INDF1BUF,W,ACCE
        subc     INDF0,W,ACCE
        insz      FSR0L,F,ACCE
        nop
        insz      FSR1BUF,F,ACCE
        nop 
        dcsz     r_Len,F,ACCE
        jmp      div_rlf_md4_next
        btss     STATUS,C,ACCE
        jmp      divide_nextprog
        ;jnc      divide_nextprog
  div_sub_md4:      
        ;LDPR     MD4,FSR0
        mvl      MD4
        mvf      FSR0L,F,ACCE
        mvffs     MD2,FSR1BUF
        mvffs     mdl2,r_Len
        mvl       1            ; don't care Wreg   
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
       ; bsf      STATUS,C,ACCE
  div_sub_md4_1:        
	call	SWFSR01
	mvffs	INDF0,INDF1BUF
	call	SWFSR01
	mvf	INDF1BUF,W,ACCE
        subc     INDF0,F,ACCE
        insz      FSR1BUF,F,ACCE
        nop
        insz      FSR0L,F,ACCE 
        nop
        dcsz     r_Len,F,ACCE
        jmp      div_sub_md4_1
        mvl       1            ; don't care Wreg   
        rrfc      WREG,F,ACCE  ; for STATUS cann't be set
        ;bsf      status,c,ACCE
divide_nextprog:
        mvffs    MD3,FSR0L
        mvf     mdl3,W,ACCE
divide_endloop:
        rlfc    INDF0,F,ACCE
        insz     FSR0L,F,ACCE
        nop
        dcsz    WREG,F,ACCE
        jmp     divide_endloop
        dcsz    S_REG,F,ACCE
        jmp     divlopk
        ret

;================================================================
; ʮתʮ (ҪͬһBank)
; FSR1L    ʮƵļӵַ
; FSR0L    ʮƵļӵַ
; WREG      
; MD1 , MD2 , r_Len, MDL1, MDL2 Ĵ
;Cycle (2 byte ) = 1278
;================================================================
htob:
        mvf     r_Len,F,ACCE
        mvffs    FSR0L,MD1
        mvffs    FSR1BUF,MD2
        inf     r_Len,W,ACCE
        call    CLEAR
        mvffs    MD1,FSR0L
        bcf     status,c,ACCE
        rlfc     r_Len,W,ACCE
        rlfc     WREG,f,ACCE
        rlf      WREG,f,ACCE
        mvf      MDL1,F,ACCE
        BCF     STATUS,C,ACCE
htob_Lp:
        mvffs     r_Len,r_Len_c
  htob_fsr1:
	call	SWFSR01
        rlfc    INDF0,F,ACCE
	call	SWFSR01
        insz     FSR1BUF,F,ACCE
        nop
        dcsz    r_Len_c,F,ACCE
        jmp     htob_fsr1
        insz     r_Len,W,ACCE
        nop
  htob_fsr0:
        rlfc    INDF0,F,ACCE
        insz    FSR0L,F,ACCE
        nop
        dcsz    WREG,F,ACCE
        jmp     htob_fsr0
        mvffs    MD1,FSR0L
        mvffs    MD2,FSR1BUF
        dcsz    MDL1,F,ACCE
        jmp     htob_adj
        ret
htob_adj:
        insz     r_Len,W,ACCE
        nop
        mvf     MDL2,F,ACCE
  htob_adj_lop:
        call    AdjBcd
        inf     FSR0L,F,ACCE
        dcsz    MDL2,F,ACCE
        jmp     htob_adj_lop
        mvffs    MD1,FSR0L
        jmp    htob_Lp
;--------
AdjBcd:
	mvl	03h
        addf    INDF0,w,ACCE
        btsz    WREG,3,ACCE
        mvf     INDF0,F,ACCE
	mvl	30h
        addf    INDF0,W,ACCE
        btsz    WREG,7,ACCE
        mvf     INDF0,F,ACCE
	ret

;================================================================
; ʮתʮ  (ҪͬһBank)
; FSR1L    ʮƵļӵַ
; FSR0L    ʮƵļӵַ
; WREG      
; MD1 , MD2 , r_Len, MDL1, MDL2 Ĵ
;Cycle (2 byte ) = 983
;================================================================
btoh:
        mvf     r_Len,F,ACCE
        dcf     r_Len,w,ACCE
        addf    FSR1BUF,F,ACCE
        addf    FSR0L,F,ACCE
        mvffs    FSR1BUF,MD2
        mvffs    FSR0L,MD1
        mvf     r_Len,W,ACCE
     BtoH_dec:   
        clrf    INDF0,ACCE
        dcf     FSR0L,F,ACCE
        dcsz    WREG,F,ACCE
        jmp     BtoH_dec
        mvffs    MD1,FSR0L
        bcf     status,c,ACCE
        rlfc     r_Len,W,ACCE
        rlfc     WREG,F,ACCE
        rlfc     WREG,F,ACCE
        mvf     MDL1,F,ACCE
btoh_LP:
        BCF     STATUS,C,ACCE
        mvffs     r_Len,r_Len_c
 btoh_LP_fsr1:
	call	SWFSR01
        rrfc    INDF0,F,ACCE
	call	SWFSR01
        dcsz    FSR1BUF,F,ACCE
        nop
        dcsz    r_Len_c,F,ACCE
        jmp     btoh_LP_fsr1
        mvf     r_Len,W,ACCE
 btoh_Lp_fsr0:
        rrfc    INDF0,F,ACCE
        dcsz    FSR0L,F,ACCE
        nop
        dcsz    WREG,F,ACCE
        jmp     btoh_Lp_fsr0
        mvffs    md1,FSR0L
        mvffs    md2,FSR1BUF
        dcsz    MDL1,F,ACCE
        jmp     btoh_adj
        ret

btoh_adj:
        mvffs    r_Len,MDL2
        mvffs    md2,FSR0L
 btoh_adj_lop:
        call    AdjHex
        dcf     FSR0L,F,ACCE
        dcsz    MDL2,F,ACCE
        jmp     btoh_adj_lop
        mvffs    md2,FSR1BUF
        jmp     btoh_LP
;---------
AdjHex:
        mvl     3
        btsz    INDF0,3
        subf    INDF0,f
        mvl     030h
        btsz    INDF0,7
        subf    INDF0,f
        ret


